# SPDX-FileCopyrightText: 2025 Lubin Bailly <lubin.bailly@dgnum.eu>
#
# SPDX-License-Identifier: EUPL-1.2

{
  dgn-hardware = {
    model = "EX4400-24X";
    extensions = [ "EX4400-EM-4Y" ];
  };

  vlans."hackdays".id = 999;

  dgn-isp = {
    enable = true;
    admin-ip = "fd26:baf9:d250:8000::1010/64";
    core-links = [
      "xe-0/0/0"
      "xe-0/0/3"
      "xe-0/0/22"
      "xe-0/0/21"
    ];
  };
  dgn-interfaces = {
    "ge-0/0/23".ethernet-switching = {
      interface-mode = "trunk";
      vlans = [ "uplink-cri" ];
    };
    "xe-0/0/0".ethernet-switching.vlans = [ "uplink-cri" ];
    "xe-0/0/21".ethernet-switching.vlans = [
      "all"
      "hackdays"
    ];
    "xe-0/0/22".ethernet-switching.vlans = [
      "all"
      "hackdays"
    ];
    "xe-0/0/20".ethernet-switching = {
      interface-mode = "access";
      vlans = [ "hackdays" ];
    };

    # debug management
    "me0".inet.addresses = [ "192.168.2.3/24" ];
  };
  dgn-profiles."hypervisor" = {
    interfaces = [
      "xe-0/0/4"
      "xe-0/0/5"
      "xe-0/0/6"
      "xe-0/0/7"
      "xe-0/0/8"
      "xe-0/0/9"
    ];
    configuration.ethernet-switching = {
      interface-mode = "access";
      vlans = [ "hypervisor" ];
    };
  };
}
