# SPDX-FileCopyrightText: 2024 Lubin Bailly <lubin.bailly@dgnum.eu>
#
# SPDX-License-Identifier: EUPL-1.2
{ lib, ... }:
let
  inherit (lib) fixedWidthNumber mapAttrs;
  inherit (lib.extra) genFuse;

  hashedPassword = "$2b$05$3h26h8rJ5yks1vJYXZG.fuHagYBwrVMlGR7iFmsV1FTJlMUj97fl2";
  mkSwitch =
    {
      site,
      ip,
      entry,
    }:
    {
      inherit site hashedPassword;

      stateVersion = null;
      adminGroups = [ "fai" ];
      deployment = {
        targetHost = ip;
        sshOptions = [
          "-J"
          entry
          "-p"
          "830"
        ];
      };
      nixpkgs = {
        version = "unstable";
        system = "netconf";
      };
    };
in
{
  nodes = mapAttrs (_: mkSwitch) (
    {
      netcore01 = {
        site = "pot01";
        ip = "fd26:baf9:d250:8000::1010";
        entry = "root@vault01.hyp01.infra.dgnum.eu";
      };

      netcore02 = {
        site = "pot01";
        ip = "fd26:baf9:d250:8000::100f";
        entry = "root@vault01.hyp01.infra.dgnum.eu";
      };

      Jaccess01 = {
        site = "hyp01";
        ip = "fd26:baf9:d250:8000::1001";
        entry = "root@vault01.hyp01.infra.dgnum.eu";
      };

      Jaccess04 = {
        site = "hyp02";
        ip = "fd26:baf9:d250:8000::2001";
        entry = "root@vault01.hyp01.infra.dgnum.eu";
      };
    }
    // genFuse (i: {
      "swHackdays${fixedWidthNumber 2 (i + 1)}" = {
        site = "none";
        ip = "192.168.0.${toString (i + 2)}";
        entry = "root@vault01.hyp01.infra.dgnum.eu";
      };
    }) 12
  );
}
